/* ARCADEmini simulator DLL
 * version 1.3.1 date 2005-10-19
 * part of the ARCADEmini project - http[s]://arcademini.schuermans.info/
 * Copyright (C) 2003-2005 sphaera <sphaera@geekness.de>
 *                     and 1stein <1stein@schuermans.info>
 * Copyleft: GNU public license - http://www.gnu.org/copyleft/gpl.html
 */

#ifndef INC_ArcadeMiniSim
#define INC_ArcadeMiniSim

//-------------------------------------------------------------------------------------------
// get information about simulator
//-------------------------------------------------------------------------------------------
void _stdcall ArcadeMiniSimInfo( char * pBuffer, unsigned long BufferLen );

//-------------------------------------------------------------------------------------------
// initialize a simulator
//-------------------------------------------------------------------------------------------
void * _stdcall ArcadeMiniSimInit( char * Filename );

//-------------------------------------------------------------------------------------------
// initialize a simulator with log file
//-------------------------------------------------------------------------------------------
void * _stdcall ArcadeMiniSimInitLog( char * Filename, char * LogFilename );

//-------------------------------------------------------------------------------------------
// cleanup a simulator
//-------------------------------------------------------------------------------------------
void _stdcall ArcadeMiniSimExit( void * p_sim );

//-------------------------------------------------------------------------------------------
// do a step
// (returns number of milliseconds of current delay or 0 if not waiting for a delay)
//-------------------------------------------------------------------------------------------
unsigned short _stdcall ArcadeMiniSimStep( void * p_sim );

//-------------------------------------------------------------------------------------------
// get the current picture
// picture must point to a buffer with 520 bytes
// returns 0 if no new picture is available
//-------------------------------------------------------------------------------------------
int _stdcall ArcadeMiniSimGetPicture( void * p_sim, char * p_picture );

//-------------------------------------------------------------------------------------------
// set the current state of the keys
//-------------------------------------------------------------------------------------------
void _stdcall ArcadeMiniSimSetKeyState( void * p_sim, unsigned char keystate );

//-------------------------------------------------------------------------------------------
// set the current state of the snes keys
//-------------------------------------------------------------------------------------------
void _stdcall ArcadeMiniSimSetSnesKeyState( void * p_sim, unsigned char snes_no, unsigned short keystate );

#endif //#ifndef INC_ArcadeMiniSim
